*----------------------------------------------------------------
*
*   Load Device Structure
*
*----------------------------------------------------------------
LOAD_STACK_SIZE      EQU 200
    STRUCTURE	LD,DD_SIZE
	STRUCT	LD_Semaphore,SS_SIZE
	STRUCT	LD_TimerRequest,IOTV_SIZE
	STRUCT	LD_TimerPort,MP_SIZE
	STRUCT	LD_Port,MP_SIZE
	STRUCT	LD_TaskCB,TC_SIZE
	STRUCT	LD_Stack,LOAD_STACK_SIZE
	ULONG	LD_seglist
	ULONG	LD_sysbase
	UWORD	LD_Interval	  ; Interval in seconds
	UWORD	LD_Ticks	  ; Number of measurements / time interval
	ULONG	LD_secs 	  ; seconds between ticks
	ULONG	LD_micro	  ; microseconds between ticks
	ULONG	LD_Max_Chip	  ; absolute maximum chip memory available
	ULONG	LD_Max_Fast	  ; absolute maximum fast memory available
	ULONG	LD_CPU
	ULONG	LD_BLITTER
	ULONG	LD_CHIP
	ULONG	LD_FAST
	UBYTE	LD_stop_count
	UBYTE	LD_flags
    LABEL	LD_SIZE

*----------------------------------------------------------------
*
*   Load Request Structure
*
*----------------------------------------------------------------

    STRUCTURE	LR,IO_SIZE
	ULONG	    LV_CPU
	ULONG	    LV_BLITTER
	ULONG	    LV_CHIP
	ULONG	    LV_FAST
	UWORD	    LV_INTERVAL
	UWORD	    LV_TICKS
	BYTE	    LV_PRI
    LABEL	LR_SIZE

LOADNAME    MACRO
	    DC.B    'load.device',0
	    ENDM

	BITDEF	    LD,OPEN_EXCL,0
LDERR_IN_USE	    EQU -5
LDERR_ACCESS_DENIED EQU -6
LDERR_NOT_STOPPED   EQU -7

	DEVINIT
	DEVCMD	LD_SET
