#ifndef LAVD_H
#define LAVD_H

typedef enum ReqType {
LAV_STOP, LAV_LOAD, LAV_LOADS, LAV_UP, LAV_ALL
} ReqType;

/* 
	LAV_STOP: Quit.
	LAV_LOAD: Return the load average now.
	LAV_LOADS: Return all three load averages.
	LAV_UP: Return the number of seconds the system has been up.
	LAV_ALL: Return LAV_LOAD and LAV_UP.
*/

/* Structure of the messages passed to and from the demon. */

typedef struct lavdmsg {
	struct Message lm_Message;

	ReqType	Class;

	ULONG	Uptime;
	int	L1;	/* Load averages. */
	int	L2;
	int	L3;
} lavdMsg;

#endif
