/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
* |_o_o|\\ Copyright (c) 1989 The Software Distillery.                    *
* |. o.| ||          All Rights Reserved                                  *
* | .  | ||          Written by John Toebes and Doug Walker               *
* | o  | ||          The Software Distillery                              *
* |  . |//           235 Trillingham Lane                                 *
* ======             Cary, NC 27513                                       *
*                    BBS:(919)-471-6436                                   *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#include "pickpack.h"
#include "struct.h"
#include "fhgen.h"

static struct IntuiText IText =
{
	1,0,JAM2,   /* front and back text pens, drawmode and fill byte */
	0,0,        /* XY origin relative to container TopLeft */
	&TOPAZ80,   /* font pointer or NULL for default */
	NULL,       /* pointer to text */
	NULL        /* next IntuiText structure */
};

static struct IntuiText NameText = {
	3,0,JAM2,   /* front and back text pens, drawmode and fill byte */
	0,0,        /* XY origin relative to container TopLeft */
	&TOPAZ80,   /* font pointer or NULL for default */
	NULL,       /* pointer to text */
	NULL        /* next IntuiText structure */
};


void stfhnew(nw, it, stnode)
struct NewWindow **nw;
struct IntuiText **it;
struct STNODE *stnode;
{
   *nw = &NewWindowStructure1;
   *it = NULL;
   return;
}


/* Display the struct FileHandle */
int stfhdisp(n)
struct STNODE *n;
{
   char data[100];
   struct FileHandle *fh;
   char *p;
   INITTEXT(14)

   BUG(1, ("stfhdisp: Entry, stnode 0x%08x window 0x%08x\n", n, n->w))

   fh = n->d.fh;

   NameText.IText = (UBYTE *)data;

   if (n->oname && n->oname[0] != ' ')
      sprintf(data, "Opened as: %s", n->oname);
   else
      sprintf(data, "Not currently active                      ");
   SHOWNAME

   sprintf(data, " fh_Link: 0x%08x (Unused)", fh->fh_Link);
   SHOWTEXT

   if (fh->fh_Port) p = "(INTERACTIVE)    ";
   else             p = "(NON-INTERACTIVE)";
   sprintf(data, " fh_Port: 0x%08x", fh->fh_Port);
   SHOWTEXT

   sprintf(data, " fh_Type: 0x%08x (Handler Process)", fh->fh_Type);
   SHOWTEXT

   sprintf(data, "  fh_Buf: 0x%08x (Internal Buffer)", fh->fh_Buf);
   SHOWTEXT

   sprintf(data, "  fh_Pos: 0x%08x (Internal Position)", fh->fh_Pos);
   SHOWTEXT

   sprintf(data, "  fh_End: 0x%08x (Internal End Pos)", fh->fh_End);
   SHOWTEXT

   sprintf(data, "fh_Func1: 0x%08x (Read Function)", fh->fh_Func1);
   SHOWTEXT

   sprintf(data, "fh_Func2: 0x%08x (Write Function)", fh->fh_Func2);
   SHOWTEXT

   sprintf(data, "fh_Func3: 0x%08x (Close Function)", fh->fh_Func3);
   SHOWTEXT

   sprintf(data, " fh_Arg1: 0x%08x (Handler Dependent)", fh->fh_Arg1);
   SHOWTEXT

   sprintf(data, " fh_Arg2: 0x%08x (Handler Dependent)", fh->fh_Arg2);
   SHOWTEXT

   BUG(1, ("stfhdisp: Exit\n"))
   return(RC_OK);
}
