#ifndef _INLINE_SYSLOG_H
#define _INLINE_SYSLOG_H

#include <sys/cdefs.h>
#include <inline/stubs.h>

__BEGIN_DECLS

#ifndef BASE_EXT_DECL
#define BASE_EXT_DECL
#define BASE_EXT_DECL0 extern struct Library * SysLogBase;
#endif
#ifndef BASE_PAR_DECL
#define BASE_PAR_DECL
#define BASE_PAR_DECL0 void
#endif
#ifndef BASE_NAME
#define BASE_NAME SysLogBase
#endif

BASE_EXT_DECL0

extern __inline struct SysLogSpy *
AddSysLogSpy (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct SysLogSpy * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x30)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
extern __inline void 
DeleteSysLogMessage (BASE_PAR_DECL struct SysLogMessage *message)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysLogMessage *a0 __asm("a0") = message;
  __asm __volatile ("jsr a6@(-0x24)"
  : /* no output */
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
}
extern __inline void 
GetSysLogMsgTime (BASE_PAR_DECL struct SysLogMessage * syslogmessage)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysLogMessage * a0 __asm("a0") = syslogmessage;
  __asm __volatile ("jsr a6@(-0x2a)"
  : /* no output */
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
}
extern __inline void 
Log (BASE_PAR_DECL LONG priority,LONG options,UBYTE *tag,UBYTE *message,LONG *argarray)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register LONG d0 __asm("d0") = priority;
  register LONG d1 __asm("d1") = options;
  register UBYTE *a0 __asm("a0") = tag;
  register UBYTE *a1 __asm("a1") = message;
  register LONG *a2 __asm("a2") = argarray;
  __asm __volatile ("jsr a6@(-0x1e)"
  : /* no output */
  : "r" (a6), "r" (d0), "r" (d1), "r" (a0), "r" (a1), "r" (a2)
  : "a0","a1","a2","d0","d1", "memory");
}
extern __inline void 
RemSysLogSpy (BASE_PAR_DECL struct SysLogSpy *spy)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysLogSpy *a0 __asm("a0") = spy;
  __asm __volatile ("jsr a6@(-0x36)"
  : /* no output */
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
}

#undef BASE_EXT_DECL
#undef BASE_EXT_DECL0
#undef BASE_PAR_DECL
#undef BASE_PAR_DECL0
#undef BASE_NAME

__END_DECLS

#endif /* _INLINE_SYSLOG_H */
